package crafttweaker.mc1120.block;

import crafttweaker.api.block.*;
import crafttweaker.api.data.IData;
import crafttweaker.api.minecraft.CraftTweakerMC;
import net.minecraft.block.Block;
import net.minecraft.item.ItemStack;
import net.minecraftforge.oredict.OreDictionary;

import java.util.*;

/**
 * @author Stan
 */
public class MCItemBlock implements IBlock {

    private final ItemStack item;

    public MCItemBlock(ItemStack item) {
        this.item = item;
    }

    @Override
    public IBlockDefinition getDefinition() {
        return CraftTweakerMC.getBlockDefinition(Block.func_149634_a(item.func_77973_b()));
    }

    @Override
    public int getMeta() {
        return item.func_77952_i();
    }

    @Override
    public IData getTileData() {
        if(!item.func_190926_b()) {
            return null;
        }
        if(item.func_77978_p() == null)
            return null;

        return CraftTweakerMC.getIData(item.func_77978_p());
    }

    @Override
    public String getDisplayName() {
        return item.func_82833_r();
    }

    @Override
    public List<IBlock> getBlocks() {
        return Collections.singletonList(this);
    }

    @Override
    public boolean matches(IBlock block) {
        return getDefinition() == block.getDefinition() && (getMeta() == OreDictionary.WILDCARD_VALUE || getMeta() == block.getMeta()) && (getTileData() == null || (block.getTileData() != null && block.getTileData().contains(getTileData())));
    }

    @Override
    public IBlockPattern or(IBlockPattern pattern) {
        return new BlockPatternOr(this, pattern);
    }
}
